/* TODO:
    re-write sequence pruning system to not use regex - I want to speed it up. Ideally I can somehow make all image sequences an array within the main array of all items, and only display
    the first item in the aray (which would be the first image).
*/
{
    //----| Build UI
    var stImporterWin = new Window("palette", "ST Import Panel");
        stImporterWin.orientation = "column";

    var browserGroup = stImporterWin.add("group");
        browserGroup.add("statictext", undefined, "Folder: ");
        var rootFolderTxt = browserGroup.add("edittext", undefined, "...Folder Location");
            rootFolderTxt.characters = 20;
        var browseBtn = browserGroup.add("button", undefined, "Browse");

    var imageSequenceGroup = stImporterWin.add("group");
        imageSequenceGroup.orientation = "column";
        var imageSequenceTree = imageSequenceGroup.add("treeview", [0,0,350,400]);
            //imageSequenceTree.alignment = "right";
        var importList = imageSequenceGroup.add("listbox", [0,0,350,100]);
            importList.alignment = "right";


    var bottomGroup = stImporterWin.add("group");
        var refreshBtn = bottomGroup.add("button", undefined, "Refresh list");
        var importBtn = bottomGroup.add("button", undefined, "Import!");
        bottomGroup.add("statictext", undefined, "FPS:");
        var fpsText = bottomGroup.add("edittext");
            fpsText.characters = 4;
            fpsText.text = 29.97;

    //----| Event listeners

    browseBtn.onClick = function() {
        var rootFolder = File.saveDialog("Import items from folder...");
        rootFolder = rootFolder.toString().split("/");
        rootFolder.pop();
        rootFolder = rootFolder.join("/");
        rootFolderTxt.text = Folder.decode(rootFolder);
    }

    // I NEED THIS TO SPIT OUT AN ARRAY OF ALL FILES IN THE TREE SO THAT I CAN IMPORT THEM LATER!!
    var filesArray = [];
    refreshBtn.onClick = function() {
        imageSequenceTree.removeAll();
        //var rootFolder = Folder ("E:/Programming/AE Scripts/Import Panel/Render Folder");
        var rootFolder = Folder (rootFolderTxt.text);
        var node0 = imageSequenceTree.add("node", rootFolder.displayName);

        function buildChildNodes (currentFolder, currentNode, filesArray) {
            var folderChildren = currentFolder.getFiles().sort();
            //alert("processing: " + currentFolder.displayName);

            //prune the array for sequences
            var searcher = new RegExp("[.]\\d{4,}[.]");
            for (var i = 0; i < folderChildren.length; i++) {
                // Go through the array and strip out all elements that are the same once their numbers have been removed with a regex
                if (i > 0) {
                    currentResult = searcher.exec(folderChildren[i].name); //check if a sequence
                    if (currentResult) { // it is a sequence
                        // first parse out the comparison strings - current item and item before
                        var testNameBefore = folderChildren[i-1].name;

                        //if we have a sequence before our current item, we need to delete the numbers.
                        var beforeNum = searcher.exec(testNameBefore);
                        if (beforeNum) {
                            var testNameBefore = testNameBefore.replace(beforeNum[0].substring(0,beforeNum[0].length-1), "");  //remove the numbers from the file before
                        }

                        var testNameCurrent = folderChildren[i].name.replace(currentResult[0].substring(0,currentResult[0].length-1), "");  //remove the numbers from the current frame

                        //compare to the element before it and delete if the same!!
                        //alert(testNameBefore + "  :  " + testNameCurrent)
                        if (testNameBefore == testNameCurrent) {
                            folderChildren.splice(i, 1);
                            i--;
                        }
                    }
                }
            }

            // now lets get to work on that tree! Or recurse if we get a folder
            for (index in folderChildren) {

                if (folderChildren[index] instanceof Folder) {
                    var newNode = currentNode.add("node", folderChildren[index].displayName);
                    filesArray.push(folderChildren[index]);

                    buildChildNodes (folderChildren[index], newNode, filesArray);
                } else {
                    var newNode = currentNode.add("item", folderChildren[index].displayName);
                    filesArray.push(folderChildren[index]);                    
                }

                newNode.expanded = true;
            }

            return filesArray;
        }

        filesArray = [rootFolder];
        buildChildNodes(rootFolder, node0, filesArray);    //recursive tree building!
        node0.expanded = true;

        return filesArray;
    }

    imageSequenceTree.onDoubleClick = function  () {
        if (imageSequenceTree.selection.type == "item") {
            importList.add("item", imageSequenceTree.selection);
        }
    }

    importList.onDoubleClick = function  () {
        importList.remove(importList.selection);
    }

    importBtn.onClick = function () {
        // for each item in the list compare it to our files array and import if we get a match
        for (var i = 0; i < importList.items.length; i++) {
            for (var j = 0; j < filesArray.length; j++) {
                if (importList.items[i].text == filesArray[j].displayName) {
                    //alert("Found a match: " + filesArray[j].displayName);
                    var importOptions = new ImportOptions(filesArray[j]);
                        importOptions.sequence = true;
                    var importedFile = app.project.importFile(importOptions);
                    importedFile.mainSource.conformFrameRate = fpsText.text;
                }
            };
        };
    }

    stImporterWin.show();
}